#ifndef _ROW_H
#define _ROW_H

#include <stddef.h>  // for NULL
#include "fn.h"      // for erow


#define ABUF_INIT {NULL, 0}


void abAppend(struct abuf *ab, const char *s, int len);
void abFree(struct abuf *ab);

char *editorRowsToString(int *buflen);

int editorRowCxToRx(erow *row, int cx);
int editorRowRxToCx(erow *row, int rx);

void editorUpdateRow(erow *row);
void editorInsertRow(int at, char *s, size_t len);
void editorFreeRow(erow *row);
void editorDelRow(int at);

void editorRowInsertChar(erow *row, int at, int c);
void editorRowAppendString(erow *row, char *s, size_t len);
void editorRowDelChar(erow *row, int at);

#endif

